theory Demo07
  imports "HOL-Library.Multiset"
begin

declare [[names_short]] (*since List.rev already exists*)

fun rev :: "'a list \<Rightarrow> 'a list"
  where
    "rev [] = []"
  | "rev (x # xs) = rev xs @ [x]"

code_thms rev
export_code rev in Haskell
  (*file "generated/"*)



fun itrev :: "'a list \<Rightarrow> 'a list \<Rightarrow> 'a list"
  where
    "itrev [] acc = acc"
  | "itrev (x # xs) acc = itrev xs (x # acc)"

lemma itrev_rev [simp]: "itrev xs ys = rev xs @ ys"
  by (induction xs arbitrary: ys) auto

lemma rev_code [code]: "rev xs = itrev xs []" by simp

code_thms rev
export_code rev in Haskell



definition evens :: "nat set"
  where
    "evens = {n::nat. even n}"

definition is_even :: "nat \<Rightarrow> bool"
  where
    "is_even n \<longleftrightarrow> n \<in> evens"

(*export_code is_even in Haskell*)

lemma in_evens_code [code_unfold]: "n \<in> evens \<longleftrightarrow> even n" by (auto simp: evens_def)

export_code is_even in Haskell



inductive ev :: "nat \<Rightarrow> bool"
  where
    "ev 0"
  | "ev x \<Longrightarrow> ev (Suc (Suc x))"

(*export_code ev in Haskell*)

lemma ev_code [code]:
  "ev x \<longleftrightarrow> 2 dvd x"
  sorry

export_code ev in Haskell



fun qsort :: "nat list \<Rightarrow> nat list"
  where
    "qsort [] = []"
  | "qsort (x # xs) = qsort (filter ((>) x) xs) @ [x] @ qsort (filter ((\<le>) x) xs)"

thm qsort.induct

export_code qsort in Haskell



value "filter_mset even {#1,1,2,3,4,4#} :: nat multiset"

lemma filter_mset_sum_id:
  assumes "\<forall>x. P x \<longleftrightarrow> \<not> Q x"
  shows "filter_mset P M + filter_mset Q M = M"
  sorry

lemma mset_qsort [simp]:
  "mset (qsort xs) = mset xs"
  sorry

end
